/* 
 *  rocks/ctl_win.c
 *
 *  Windows heartbeat/reconnect control thread.
 *
 *  Copyright (C) 2001 Victor Zandy, Greg Quinn
 *  See COPYING for distribution terms.
 */

#include <process.h>

#include "rs.h"
#include "rs_win.h"

static DWORD WINAPI ctl_thread_func(PVOID);

int rs_start_ctl(rs_t rs) {

	rs->plat_dep.ctl_thread = (HANDLE)_beginthreadex(NULL, 0,
	                                                 ctl_thread_func,
	                                                 (LPVOID)rs, 0, NULL);
	Sleep(50);
	if (rs->plat_dep.ctl_thread == NULL)
		return -1;

	return 0;
}

/* this is the thread function executed by the control thread */
static DWORD WINAPI ctl_thread_func(PVOID pvParam) {

	rs_t rs = (rs_t)pvParam;

	rs->plat_dep.ctl_thread_id = GetCurrentThreadId();

	/* start in heartbeat mode */
	do_heartbeat(rs);

	return 0;
}