/*
 *  rocks/pi.h
 *
 *  Platform independent abstraction layer for system/library operations.
 *
 *  Copyright (C) 2003 Victor Zandy, Greg Quinn
 *  See COPYING for distribution terms.
 */

#ifndef _PI_H_
#define _PI_H_

/* import the type abstractions */
#ifdef WIN32
#include "pi_win.h"
#else
#include "pi_unix.h"
#endif

int pi_closesocket(socket_t);
int pi_ioctl(socket_t, ioctlcmd_t, ioctlarg_t);
int pi_closefile(int);
int pi_gettimeofday(struct timeval *, timezone_t);
int pi_getpid();
int pi_isatty(int);
int pi_dup(int);
int pi_dup2(int, int);
int pi_snprintf(char *, size_t, const char *, ...);
int pi_nonblock(socket_t, int);
int pi_sitfor();
int pi_socket_errno();
void pi_set_socket_errno(int);

#endif
