/*
 * rocks/pi_unix.h
 *
 * Type abstractions and constants for hiding
 * UNIX-specifics
 */

#ifndef _PI_UNIX_H
#define _PI_UNIX_H

#include <sys/types.h>
#include <sys/wait.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/poll.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>
#include <dirent.h>
#include <netdb.h>
#include <unistd.h>
#include <signal.h>

/* platform dependent rocks structure */
typedef struct {
	int dummy;
} rs_platform_t;

typedef int socket_t;
typedef socklen_t salen_t;
typedef void * iobuff_t;
typedef size_t iosize_t;
typedef ssize_t ioret_t;
typedef int ioctlcmd_t;
typedef char * ioctlarg_t;
typedef struct timezone * timezone_t;

#define DEFAULT_LOG "/tmp/rocks"
#define INVALID_SOCKET -1
#define SOCKET_ERROR -1

#endif
