/*
 * rocks/rslist_unix.h
 */

#include "rs.h"
#include "rslist.h"
#include <assert.h>

static rs_t rocks[RS_MAXFD];

int rs_add_rock(rs_t rs) {

	assert(!rocks[rs->sd]);
	rocks[rs->sd] = rs;
	return rs->sd;
}

int rs_add_nonrock(int sd) {

	assert(!rocks[sd]);
	return sd;
}

int rs_remove_node(int sd) {

	assert(rocks[sd]);
	rocks[sd] = NULL;
	return 0;
}

int rs_lookup_socket(int sd) {

	return sd;
}

rs_t rs_lookup(int sd) {

	return rocks[sd];
}

void rs_unrock(rs_t rs) {

	assert(rocks[rs->sd]);
	rocks[rs->sd] = NULL;
}

int rs_rebind_rock(rs_t rs, int sd) {

	assert(rocks[sd]);
	if (rs->sd != sd) {
		assert(!dup2(sd, rs->sd));
		close(sd);
	}

	return rs->sd;
}

/* Set fd NEW to be same rock as fd OLD */
void
rs_share_rockfd(int old, int new)
{
	rs_t rs;
	rs = rs_lookup(old);
	assert(rs);
	assert(!rocks[new]); /* new must not have a rock already 
					    (e.g., if dup returns it, it should not be in use) */
	rocks[new] = rs;
	if (rs_rock_is_shared(rs)) {
		rs_shm_lock(rs->shm);
		rs->shm->refcnt++;
		rs_shm_unlock(rs->shm);
	} else
		rs->refcnt++;
}
