/* 
 *  rocks/test/test_ring.c
 *
 *  Ring buffer test program.
 *
 *  Copyright (C) 2001 Victor Zandy
 *  See COPYING for distribution terms.
 */
#include <stdio.h>
#include <stdlib.h>
#include "ring.h"
#include "log.h"

int
main()
{
	ring_t ring;
	char buf[256];
	unsigned int x;
	char *p;

	rs_startlog(NULL, 0);
	ring = rs_new_ring(1024);
	if (!ring) {
		fprintf(stderr, "Can't allocate ring.\n");
		return -1;
	}
	for (x = 0; x < 256; x++)
		buf[x] = x;
	rs_push_ring(ring, buf, 256);
	p = rs_ring_data(ring);
	if (p[0] == buf[0])
		fprintf(stderr, "BEFORE: Ring seq works\n");
	else
		fprintf(stderr, "BEFORE: Ring seq does not work: p[0] = %d\n", p[0]);
	rs_set_ring_seq(ring, 100);
	p = rs_ring_data(ring);
	if (p[0] == buf[100])
		fprintf(stderr, "AFTER: Ring seq works\n");
	else
		fprintf(stderr, "AFTER: Ring seq does not work: p[0] = %d\n", p[0]);
	return 0;
}
